/*
 * Params:
 * item: iot item for edit or null for create
 */
lm.component('lmDialogThingCrup', {
	templateUrl: 'comp/dialog/lmDialogThingCrup.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($element, $http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.sensorTypes = ["SENSOR_BOOLEAN", "SENSOR_COORDINATE", "SENSOR_FIRE", "SENSOR_NUMBER", "SENSOR_STRING", "CONTROL_SWITCH", "CONTROL_FIRE", "CONTROL_SELECT", "CONTROL_PERCENT", "CONTROL_TEXT", "CONTROL_NUMBER"];
		ctrl.item = null;
		
		ctrl.elementOutside = $element.get(0);
		
		ctrl.$onInit = function() {
			if(ctrl.lmParams.item) {
				ctrl.item = ctrl.lmParams.item;
				ctrl.create = false;
				ctrl.req = {name: ctrl.item.name, uid: ctrl.item.uid, persistent: ctrl.item.persistent, type: ctrl.item.type, unit: ctrl.item.unit, type: ctrl.item.type, selectStringOptions: angular.copy(ctrl.item.options)};
			}
			else {
				ctrl.create = true;
				ctrl.req = {name: '', uid: '', type: '', unit: '', persistent: true, type: ctrl.sensorTypes[0], selectStringOptions: []};
				$http.get(lmBase.url + 'util/uid').then(
					function success(resp) {
						ctrl.req.uid = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}

			$http.get(lmBase.url + 'iot/item/' + ctrl.item.id + '/action').then(
				function success(resp) {
					if(resp.data.action != null) {
						ctrl.action = resp.data.action;
					}
				},
				serviceLimboMedia.handleHttpErrorNew
			);			
		};
		
		ctrl.doShrink = function(valMode,valTimeunit) {
			var re = {mode: valMode, timeUnit: valTimeunit};
			$http.post(lmBase.url + 'iot/item/' + ctrl.item.id + '/aggregate', re).then(
				function success(resp) {
					ctrl.lmDone();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.ok = function() {
			if(ctrl.create) {
				$http.post(lmBase.url + 'iot/item', ctrl.req).then(
					function success(resp) {
						ctrl.lmDone();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
			else {
				$http.post(lmBase.url + 'iot/item/' + ctrl.item.id,ctrl.req).then(
					function success(resp) {
						ctrl.lmDone();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
		};
	}
});
