lm.component('lmNav', {
	templateUrl: 'comp/misc/lmNav.' + lmCacheTag + 'html',
	bindings: { },
	controller: function($scope,$element,$location,$timeout, serviceLimboMedia,serviceMediaPlayer,serviceSidebar) {
		var ctrl = this;
		
		ctrl.elBurgerDown = $element.find('.burgerDown');
		ctrl.elSettingsDown = $element.find('.settingsDown');
		
		ctrl.userdetails = serviceLimboMedia.userdetails;

		ctrl.navItems = [
			{name: 'Files', key: 'FILEMEDIA', path: '/files', active: false, ico: 'icon-folder-light-open'},
			{name: 'Bookmarks', key: 'BOOKMARKS', path: '/bookmarks', active: false, ico: 'icon-bookmark'},
			{name: 'ToDos', key: 'TODOS', path: '/todos', active: false, ico: 'icon-checked'},
			{name: 'Notes', key: 'NOTES', path: '/notes', active: false, ico: 'icon-note'},
			{name: 'IoT', key: 'IOT', path: '/iot', active: false, ico: 'icon-bulb'}
		];

		$scope.$on('$routeChangeSuccess', function(scope, current, pre) {
			for(x in ctrl.navItems) {
				var item = ctrl.navItems[x];
				item.active = $location.path().indexOf(item.path) == 0;
			}
	    });
	    
		ctrl.logout = function() {
			serviceLimboMedia.logout();
		};
		
		/* sidebar */
		ctrl.sidebarState = serviceSidebar.state;
		
		ctrl.mediaToggle = function() {
			serviceSidebar.toggleShow();
		};
		
		/* navdown with backdrop */
		ctrl.navdownShow = false;
		
		ctrl.navdownBackdrop = function() {
			$scope.$apply(function() {
				ctrl.navdownToggle();
			});
		};
		
		ctrl.navdownToggle = function() {
			if(ctrl.navdownShow) {
				ctrl.navdownShow = false;
				document.removeEventListener('click', ctrl.navdownBackdrop);
			}
			else {
				ctrl.navdownShow = true;
				$timeout(function() {
					document.addEventListener('click', ctrl.navdownBackdrop);
				});
			}
		};
		
		/* setdown with backdrop */
		ctrl.setdownShow = false;
		
		ctrl.setdownBackdrop = function() {
			$scope.$apply(function() {
				ctrl.setdownToggle();
			});
		};
		
		ctrl.setdownToggle = function(event) {
			if(event) {
				var rect = event.target.getBoundingClientRect();
				ctrl.elSettingsDown.css("right","auto");
				ctrl.elSettingsDown.css("left",(rect.left - 16)  + "px");
			}
			else {
				ctrl.elSettingsDown.css("right","0px");
				ctrl.elSettingsDown.css("left","auto");
			}
			
			if(ctrl.setdownShow) {
				ctrl.setdownShow = false;
				document.removeEventListener('click', ctrl.setdownBackdrop);
			}
			else {
				ctrl.setdownShow = true;
				$timeout(function() {
					document.addEventListener('click', ctrl.setdownBackdrop);
				});
			}
		};		
		
	}


});