lm.component('pageAppEditor', {
  templateUrl: 'comp/page/pageAppEditor.' + lmCacheTag + 'html',
  bindings: {
	  
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($scope, $http,serviceLimboMedia,serviceNotification,serviceModal) {
	  var ctrl = this;
	  ctrl.paramFileId = null;
	  ctrl.file = null;
	  ctrl.fileText = null;
	  ctrl.content = '';
	  ctrl.readonly = false;
	  
	  /* settings */
	  ctrl.settings = {};
	  
	  ctrl.loadSettings = function() {
		  ctrl.settings = serviceLimboMedia.getRemoteSettings('appEditor');
		  if(ctrl.settings.charset == null) ctrl.settings.charset = lmBase.charsets[0];
	  };

	  ctrl.saveSettings = function() {
		  serviceLimboMedia.saveRemoteSettings('appEditor');
	  };

	  /* init */
	  ctrl.$onInit = function() {
		  ctrl.loadSettings();
	  };
	  
	  ctrl.$routerOnActivate = function(next) {
		  ctrl.paramFileId = next.params.fileId;
		  ctrl.loadFile();
	  };
	  
	  ctrl.loadFile = function() {
		$http.get(lmBase.url + 'f/file/' + ctrl.paramFileId + '?details=true').then(
				function success(resp) {
					ctrl.file = resp.data;
					ctrl.loadContent();
				}, serviceLimboMedia.handleHttpErrorNew
		);
	  };
	  
	  ctrl.loadContent = function() {
		  $http.get(lmBase.url + 'f/file/' + ctrl.paramFileId + '/text?charset=' + ctrl.settings.charset).then(
				function success(resp) {
					ctrl.fileText = resp.data;
					ctrl.content = ctrl.fileText.content;
				}, serviceLimboMedia.handleHttpErrorNew
		  );
	  };
	  
	  ctrl.doReload = function() {
		  ctrl.loadContent();
	  };

	  ctrl.doSave = function() {
		  var req = {content: ctrl.content, charset: ctrl.settings.charset};
		  $http.post(lmBase.url + 'f/file/' + ctrl.paramFileId + '/text',req).then(
					function success(resp) {
						serviceNotification.ok('MSG_SAVED');
					}, serviceLimboMedia.handleHttpErrorNew
		  );
	  };
	  
	  ctrl.toggleConfig = function() {
		  serviceModal.show('lm-dialog-app-editor-settings').then(function() {
			  ctrl.doReload();
		  }, function() {});  
	  };
	  
  }
  
});