lm.component('pageLink', {
  templateUrl: 'comp/page/pageLink.' + lmCacheTag + 'html',
  bindings: {
  },
  controller: function(serviceLimboMedia, $http, $rootRouter, $timeout) {
	  var ctrl = this;
	  ctrl.status = 'P_LINK_PROCESSING';
	  ctrl.spinning = true;
	  ctrl.params = {};
	  
	  ctrl.doForward = function() {
		  $rootRouter.navigate(['FilesAndMedia', {id: ctrl.params.resId}]);
	  };
	  
	  ctrl.doToken = function() {
		  var req = {username: 'guest', password: ctrl.params.token};
		  $http.post(lmBase.url + 'user/login',req).then(
		  	function success(resp) {
		  		ctrl.status = 'P_LINK_OK';
		  		serviceLimboMedia.setUser(resp.data);
		  		ctrl.doForward();
		  	},
		  	function error(resp) {
		  		ctrl.status = 'P_LINK_FAIL';
		  		ctrl.spinning = false;
		  		console.log(resp.data);
		  		console.log(resp.status);
		  	}
		  );
	  };
	  
	  ctrl.$routerOnActivate = function(next) {
		  ctrl.params.resType = next.params.resType;
		  ctrl.params.resId = next.params.resId;
		  ctrl.params.token = next.params.token;

		  if(ctrl.params.resType && ctrl.params.resId && ctrl.params.token) {
			  $timeout(ctrl.doToken, 3000);
		  }
		  else {
			  ctrl.status = 'P_LINK_INVALID';
			  ctrl.spinning = false;
		  }
	  };
	  
  }
});