lm.factory('serviceDeps', [ '$rootScope', '$q', function($rootScope, $q) {
	var service = new Object();
	
	service.available = [
		{name: 'ace', url: 'js/ace/ace.js', promise: null},
		{name: 'pdf', url: 'js/pdf/pdf.js', promise: null, after: function() {PDFJS.workerSrc = 'js/pdf/pdf.worker.js'; PDFJS.cMapUrl='js/pdf/cmaps/';}},
		{name: 'plot', url: 'js/plot/allinone.min.js', promise: null},
		{name: 'leaflet', url: 'js/leaflet/allinone.js', promise: null}
	];
	
	service.load = function(valName) {
		var res = service.available.filter(function(item) {return valName == item.name})[0];
		if(!res) {
			console.log("No resource with name " + valName + ".");
			return;
		}
		if(!res.promise) {
			res.promise = $q(function(resolve, reject) {
				var script = document.createElement('script');
				script.type = 'text/javascript';
				script.src = res.url;
				
				var callback = function() {
					if(res.after) res.after();	
					resolve(true);
				};
				script.onreadystatechange = callback;
				script.onload = callback;
				document.getElementsByTagName('head')[0].appendChild(script);			
			});
		}
		
		return res.promise;
	}

	return service;
}]);
